import { useUserStore } from '../../stores/user';
import { Directive, DirectiveBinding } from 'vue';

export const hasPermi: Directive = {
  mounted(el: HTMLElement, binding: DirectiveBinding) {
    const { value } = binding;
    const all_permission = '*:*:*';
    const store = useUserStore();
    const permissions = store.permissions;

    if (value && value instanceof Array && value.length > 0) {
      const permissionFlag = value;

      const hasPermissions = permissions.some(permission => {
        return all_permission === permission || permissionFlag.includes(permission);
      });

      if (!hasPermissions) {
        el.parentNode && el.parentNode.removeChild(el);
      }
    } else {
      throw new Error(`need roles! Like v-hasPermi="['system:user:add','system:user:edit']"`);
    }
  }
};

